// dans l'exemple A n'est pas a digonale strictement dominante. 
// Solution exacte de l'exemple (-1,1,1)
// On fait tourner l'exemple en partant de (-0.5 ,1,1)
// x_1^(2) =-1 
// x_2^(2) = -1 +0.5+ 1= 0.5
// x_3^(2) = 2-1=1
//
// x_1^(3) =-0.5 
// x_2^(3) = -1 +1+ 1= 1
// x_3^(3) = 2-0.5=1.5
//
// x_1^(4) =-1 
// x_2^(4) = -1 +0.5 + 1.5= 1
// x_3^(3) = 2-1=1
public class jacobi{
    double A[][]; 
    double B[]; 
    double epsilon= 0.00001; 
    double X[]; // initialiser avec X0
    jacobi(double C[][], double B[], double X[]){
	A = new double[C.length][C[0].length];
	A=C; 
	this.X = new double[X.length];
	this.X=X; 
	this.B = new double[B.length];
	this.B=B; 
    }

    boolean dominante(){
	double somme ;
        boolean b =true; 
        for(int i=0; i< A.length; i++)  
	    { somme=0; 
		for (int j=0; j< A[i].length; j++)   
		    somme = somme + Math.abs(A[i][j]);
		somme = somme - Math.abs(A[i][i]); 
		if(Math.abs(A[i][i])<= somme )
		    return false; 
	    }
	return b; 
    }

    // Pour un tableau t donne methode qui indique si || At -B|| <= epsilon

    boolean distance ( double t[]){
	// on calcule At-B
	double temp []; 
        temp = new double[A.length]; 
        for (int i =0; i< t.length; i++){
	    for (int j=0; j< A[i].length; j++){
		temp[i]= temp[i] + A[i][j]*t[j];
	    }
	    temp[i]= temp[i]-B[i];
	}
        double sommecarre =0;
        for (int i =0; i< temp.length; i++)
	    sommecarre = sommecarre + temp[i]*temp[i];
 
        if(Math.sqrt(sommecarre) < epsilon) return true;
        else return false; 
    }

    double [] methodejacobi(){
	double s=0;
        double tempnew[];
        double tempold[]; 
        tempnew= new double[X.length];
	tempold= new double[X.length];
        // on charge la valeur initiale 
        for (int i=0; i < tempnew.length; i++)
	    tempnew[i]= X[i];

	while (!distance(tempnew)){
	    for (int i=0; i < tempnew.length; i++)
		tempold[i]= tempnew [i];

	    for(int i=0; i< tempold.length; i++)
		{
		    s=0;
		    for(int j=0; j< A[0].length; j++)
			s = s + A[i][j]*tempold[j];

		    s= s- A[i][i]*tempold[i];
		    tempnew[i]=(B[i] -s) / A[i][i];
		}


     
	}
	return tempnew;
    } 

    public static void main(String arg[]){
	double A[][] ={{1,1,0},{-1,-1,1},{0,1,1}};
        double B[] = {0,1,2};
	double X[]= {-0.5,1,1};
	jacobi j = new jacobi(A,B,X);
	double res[] = j.methodejacobi(); 
	for (int i=0; i< res.length; i++)
	    System.out.print(res[i]+ " ");
	System.out.println();  
    }
}
